'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _fsts = require('fsts');

var _utilities = require('../utilities');

var _dom = require('./dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_Component) {
  _inherits(Button, _Component);

  function Button() {
    _classCallCheck(this, Button);

    return _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).apply(this, arguments));
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          size = _props.size,
          block = _props.block,
          active = _props.active,
          as = _props.as;

      var cn = (0, _utilities.mergeClassName)(this.props, [size ? 'btn-' + size : '', block ? 'btn-block' : '', active ? 'active' : '']);
      var p = _fsts.JS.lessProps(this.props, ['type', 'className', 'size', 'block', 'outline', 'as']);
      if (active) {
        p['aria-pressed'] = 'true';
      }

      return as && as === 'a' ? _react2.default.createElement(
        _dom.BA,
        _extends({ role: 'button', className: cn }, p),
        this.props.children
      ) : _react2.default.createElement(
        _dom.BButton,
        _extends({ type: 'button', className: cn }, p),
        this.props.children
      );
    }
  }]);

  return Button;
}(_react.Component);

function purposePrefix(props) {
  var outline = props.outline;

  return outline ? 'btn-outline' : 'btn';
}

exports.default = (0, _utilities.stack)(Button, [(0, _utilities.withClassName)('btn'), (0, _utilities.withPurpose)(purposePrefix)]);